if (LibDebug) then LibDebug() end
local me,ns = ...
local abh=LibStub("AceAddon-3.0"):GetAddon(me)
local L=LibStub("AceLocale-3.0"):GetLocale(me,true)
local bs=LibStub("LibBattleScan")
local module=abh:GetModule('BFG')
local store
local rates=bs:GetRates('BFG')
function module:Config()
	abh:AddToggle("BFGSPAM",false,L["Spam your life status"])
	abh:AddSlider("BFGSPAMTHRESHOLD",20,10,80,L["Life percentage"],L["Under this life percentage you will start asking for help"])
	--abh:AddToggle("ABBARS",true,"Show status bars for contested nodes","Show a progress bar for contested nodes")
	--self:AddSlider("ABdeath",30,20,40,"Resurrection timer interval")
end
function module:Init(AceGUI,storefunc)
	store=storefunc
	self:DashBoard()
	self:SetHint(L["Take bases!"])
	self:SetPrediction()
	self:SetFinals(0,0)
end
function module:UpdateStates()
	local timeleft
    local allyBases,allyScore,hordeBases,hordeScore,final = bs:GetStatus()
    final = tonumber(final) or 1600
    local allyRate=rates[allyBases]
    local hordeRate=rates[hordeBases]
    local allySecs=math.floor((final-allyScore)/allyRate) or 0
    local hordeSecs=math.floor((final-hordeScore)/hordeRate) or 0
    local timeleft=hordeSecs
    if (allySecs <hordeSecs) then
    	timeleft=allySecs
    end
    local hfinal=min(ceil(hordeRate*timeleft) + hordeScore,final)
    local afinal=min(ceil(allyRate*timeleft) + allyScore,final)
    --print(format("Horde: possiede %d basi, cresce di %f al secondo, quindi impiegherà %d secondi",hordeBases,hordeRate,hordeSecs))
    --print(format("Ally: possiede %d basi, cresce di %f al secondo, quindi impiegherà %d secondi",allyBases,allyRate,allySecs))
    local faction
    if (allySecs > 0 or hordeSecs > 0 ) then
	    if (allySecs > hordeSecs) then
	    	faction=FACTION_HORDE
	    elseif (allySecs < hordeSecs) then
			faction=FACTION_ALLIANCE
	    else
			faction=L["none"]
		end
	end
	local hold=allyBases
	if (bs:FriendFaction()=="Horde") then hold=hordeBases end
	local needed=self:GetNeeded(allyScore,hordeScore,final)
	local formato
    if (needed <2 ) then
    	formato = L["We need just %d bases to win!"]
	elseif (needed == 2) then
		formato=L["We need %d bases to win!"]
	elseif (needed >2) then
		formato = L["We need at least %d bases to win!"]
	end
	if (needed <= hold) then
		formato=L["%d bases are enough to win now. Please defend!"]
	end	
	self:SetHint(format(formato,needed))
	self:SetPrediction(faction,timeleft)
	self:SetFinals(afinal,hfinal,43,44)
end
function module:GetNeeded(myscore, theirscore,tot)
	if (bs:FriendFaction()=="Horde") then
		local x=myscore
		myscore=theirscore
		theirscore=x
	end
	local iNeed=tot-myscore
	local theyNeed=tot-theirscore
	for i=1,2 do
		if theyNeed/rates[3-i] > iNeed/rates[i] then
			return i
		end
	end
	return 5 
end
function module:HeartBeat()
	--[===[@debug@
	store(date("%M:%S"),bs:GetStatus())
	--@end-debug@]===]
end
